addHook("AbilitySpecial", function(player)
	if player.mo.skin ~= "tails" return end
	if (player.cmd.buttons & BT_JUMP)
	and not P_IsObjectOnGround(player.mo)
	and not (player.pflags & PF_THOKKED)
	and (player.pflags & PF_JUMPED)
	and not player.fly
		player.fly = 6*TICRATE
		player.flyheight = 0*FRACUNIT
		P_InstaThrust(player.mo, player.mo.angle, 50*FRACUNIT)
		P_SetObjectMomZ(player.mo, player.flyheight, false)
		return true
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.skin ~= "tails" return end
	if player.fly == nil
		player.fly = 0*TICRATE
	end
	if player.flyheight == nil
		player.flyheight = 0*FRACUNIT
	end
	if player.flyuse == nil
		player.flyuse = 0
	end
	if player.fly > 0
		player.drawangle = player.mo.angle
		if not player.powers[pw_underwater]
			player.fly = $ - 1
		end
		if not player.powers[pw_underwater]
			if player.mo.state ~= S_PLAY_RUN
				player.mo.state = S_PLAY_RUN
			end
		else
			if player.mo.state ~= S_PLAY_SWIM
				player.mo.state = S_PLAY_SWIM
			end
		end
		if (player.cmd.buttons & BT_JUMP)
			player.flyheight = $ + FRACUNIT/2
		elseif (player.cmd.buttons & BT_USE)
			player.flyheight = $ - FRACUNIT/2
		end
		P_InstaThrust(player.mo, player.mo.angle, 50*FRACUNIT)
		P_SetObjectMomZ(player.mo, player.flyheight, false)
		if (player.cmd.buttons & BT_CUSTOM1)
			player.fly = 0
			P_SetObjectMomZ(player.mo, 40*FRACUNIT, false)
			P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT)
			player.mo.state = S_PLAY_SPRING
			player.flyuse = $ + 1
		end
		if player.flyheight > 10*FRACUNIT
			player.flyheight = 10*FRACUNIT
		elseif player.flyheight < -10*FRACUNIT
			player.flyheight = -10*FRACUNIT
		end
		if (player.cmd.buttons & BT_CUSTOM3)
			player.fly = 0
			player.mo.state = S_PLAY_ROLL
			if (player.cmd.buttons & BT_CUSTOM2)
				P_SetObjectMomZ(player.mo, -40*FRACUNIT, false)
				P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT)
			end
			player.flyuse = $ + 1
		end
		if player.powers[pw_pushing]
			player.fly = 0
			player.flyuse = $ + 1
			P_DoPlayerPain(player)
		end
	end
	if player.fly > 0
		player.powers[pw_strong] = $|STR_SPIKE|STR_WALL
	else
		player.powers[pw_strong] = STR_NONE
	end
	if player.fly == 1
		player.flyuse = $ + 1
	end
	if player.flyuse >= 2
		player.pflags = $|PF_THOKKED
		player.flyuse = 0
	end
	if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
	and not player.fly
		player.flyuse = 0
	end
	if P_IsPlayerOnGround(player)
	and player.fly
		player.fly = 0
	end
	if player.mo.z+player.mo.height == player.mo.ceilingz
	and player.fly
		player.flyheight = 0*FRACUNIT
	end
end)

addHook("PlayerCanDamage", function(player)
	if player.fly > 0
		return true
	end
end)